; You'll need FASM (http://flatassembler.net/) to compile this program.
;
; Resident Evil 3 patches v0.2 [2017/08/24]
; (c) -=CHE@TER=- 2017
; http://ctpax-cheater.losthost.org
; mailto: _CTPAX_(a)mail(.)ru
;
; Made at the request of Kalash49 for the Resident Evil 3 Restoration Project
;
; todolist
; ! IMPORTANT: discover a way to render HQ backgrounds at the place of purple masks
; - BUG: purple polygon at Jill skirt in normal outfit at right side when filling .SLD
; - adapt already existing RE3 executable patches for this library
; - add feature to replace modified resources in memory
; - add modern joysticks support (don't have joystick - how to test?)
; - add support for different versions (not only USA)
; - discover a way to render background in 24 bits (16 have too many artefacts)

format PE GUI 2.0 DLL

include 'win32a.inc'

entry DllEntryPoint

section '.text' readable executable code

;include 'structs.asm'
; single file without need of 'structs.asm'
IMAGE_DOS_HEADER.e_lfanew = 03Ch
IMAGE_NT_HEADERS.FileHeader.TimeDateStamp = 008h
IMAGE_NT_HEADERS.OptionalHeader.DataDirectory = 078h
IMAGE_DATA_DIRECTORY.VirtualAddress = 000h
IMAGE_EXPORT_DIRECTORY.NumberOfNames = 018h
IMAGE_EXPORT_DIRECTORY.AddressOfFunctions = 01Ch
IMAGE_EXPORT_DIRECTORY.AddressOfNames = 020h

; 640*2*480
SCR_SIZE = 96000h

proc GetOffs stdcall uses ecx edx, offs:DWORD
  ; get base address
  invoke GetModuleHandle, 0
  add eax, [offs]
  ret
endp

;proc DumpScreen c uses eax ecx edx
;  invoke CreateFileA, _dumpfile, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
;  cmp eax, INVALID_HANDLE_VALUE
;  jz @f
;    push eax
;    push eax
;    mov ecx, esp
;    invoke WriteFile, eax, _tgahead, 12h, ecx, 0
;    mov eax, [esp + 4]
;    mov ecx, esp
;    invoke WriteFile, eax, _scr, SCR_SIZE, ecx, 0
;    mov eax, [esp + 4]
;    invoke CloseHandle, eax
;    pop eax
;    pop eax
;  @@:
;  ret
;endp

proc CmdKeys
  ; original game code
  and eax, 00000FFFFh
  ; save
  push eax
  ; F2: toggle auto-aim
  cmp eax, 40005
  jnz @f
    stdcall GetOffs, 006628BEh ; 00A628BEh
    ; toggle auto-aim
    xor byte [eax], 040h
    xor eax, eax
  @@:
  ; F9: quit to title
  cmp eax, 40006
  jnz @f
    stdcall GetOffs, 0065C883h ; 00A5C883h
    ; ingame
    cmp byte [eax], 009h
    jz @f
    ; demo text after reset
    cmp byte [eax], 010h
    jz @f
    ; ingame before reset
    cmp byte [eax], 029h
    jz @f
    ; demo text before reset
    cmp byte [eax], 030h
    jz @f
    ; reset and go to menu
    mov byte [eax], 000h
    xor eax, eax
  @@:
  ; restore
  pop eax
  ret
endp

;proc GetAccels stdcall hInstance:DWORD, lpTableName:DWORD
;  invoke LoadAcceleratorsA, [_his], [lpTableName]
;  ret
;endp

;proc GetDDI
;  ; save ret addr
;  pop [_surf]
;  ; save interface
;  mov [_ddi], eax
;  call dword [edx + 18h]
;  ; restore addr
;  push [_surf]
;  mov  [_surf], 0
;  test eax, eax
;  ret
;endp

;proc DrawPurple
;  ; ret addr
;  pop edx
;
;  ; create surface if none
;  cmp [_surf], 0
;  jnz @f
;    mov dword [_ddsd], 7Ch          ; dwSize
;    mov dword [_ddsd +  4d], 1007h  ; dwFlags (DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS | DDSD_PIXELFORMAT)
;    mov dword [_ddsd +  8d], 480d   ; Height
;    mov dword [_ddsd + 12d], 640d   ; Width
;    mov dword [_ddsd + 76d], 40h    ; ddpfPixelFormat.dwFlags
;    mov dword [_ddsd + 84d], 10h    ; ddpfPixelFormat.dwRGBBitCount
;    mov dword [_ddsd + 104d], 4040h ; 4040h ; ddsd.ddsCaps.dwCaps (DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY)
;    push eax
;    push ecx
;    push edx
;    ; create surface
;    push NULL
;    push _surf
;    push _ddsd
;    mov eax, [_ddi]
;    push eax
;    mov eax, [eax]
;    call dword [eax + 18h] ; 73726EFC -> 73752A4F
;    pop edx
;    pop ecx
;    pop eax
;  @@:
;
;  ; draw background surface to the screen
;  push eax
;  push ecx
;  push edx
;  push esi
;  push 0 ; _DDBLTFX
;  push 01000000h ; DDBLT_WAIT
;  push 0   ; src rect
;  push [_surf] ; surface
;  add esi, 0C4h
;  push esi; dst rect
;  mov edx, [eax]
;  push eax
;  call dword [edx + 14h]
;  pop esi
;  pop edx
;  pop ecx
;  pop eax
;
;  ; _DDBLTFX
;  mov [_DDBLTFX], 64h ; dwSize
;  mov [_DDBLTFX + 5Ch], 00FF00FFh ; 7C1Fh ; ddckSrcColorkey.dwColorSpaceLowValue
;  mov [_DDBLTFX + 60h], 00FF00FFh ; 7C1Fh ; ddckSrcColorkey.dwColorSpaceHighValue
;  mov dword [esp], _DDBLTFX
;  push 01010000h ; DDBLT_WAIT | DDBLT_KEYSRCOVERRIDE
;  ; restore ret address
;  push edx
;  ret
;endp

proc FillSLD c pack:DWORD, data:DWORD
; uses eax ecx edx edi,
  ; get original code offs
  stdcall GetOffs, 025330h
  ; call original code
  ccall eax, [pack], [data]
  push eax
  push ecx
  push edx
  push edi
  mov edi, [data]
  ; check .TIM magic
  cmp dword [edi], 10h
  jnz @fsq
  ; type 9 (8 BPP)
  cmp dword [edi + 04h], 09h
  jnz @fsq
    xor ecx, ecx
    ; colors in one palette
    mov cx, [edi + 10h]
    cmp cx, 0
    jz @fsq
      ; first color usually transparent - skip it
      dec cx
      ; purple filler color
      mov ax, 7C1Fh
      ; total palettes
      mov dx, [edi + 12h]
      ; offset to the first palette
      add edi, 14h
      @loops:
        push ecx
        ; skip first color
        add edi, 2
        cld
        rep stosw
        pop ecx
        dec dx
      jnz @loops
  @fsq:
  pop edi
  pop edx
  pop ecx
  pop eax
  ret
endp

;proc FillJPG stdcall uses eax ecx edx edi esi, buff:DWORD, line:DWORD, zero:DWORD
;  ; get original code offs
;  stdcall GetOffs, 0FA9D0h
;  ; call original code
;  stdcall eax, [buff], [line], [zero]
;  ; calc image size
;  mov eax, [line]
;  shr eax, 2
;  push eax
;  shr eax, 1
;  add eax, [esp]
;  pop ecx
;  mov ecx, [line]
;  xor edx, edx
;  mul ecx
;  mov ecx, eax
;  shr ecx, 1 ; because words (2 bytes)
;;;  push ecx
;  ; save original background
;  mov esi, [buff]
;  mov edi, _scr
;;;  cld
;;;  rep movsw
;  @@:
;    mov ax, [esi]
;    mov dx, ax
;    and dx, 0001Fh
;    and ax, 07FE0h
;    shl ax, 1
;    or  ax, dx
;    mov [edi], ax
;    add esi, 2
;    add edi, 2
;    dec ecx
;  jnz @b
;
;  ; ==============================================
;
;  cmp [_surf], 0
;  jz @f
;
;  ; lock surface
;  push 0 ; NULL
;  push 1 ; DDLOCK_WAIT
;  push _ddsd
;  push 0 ; NULL
;  mov eax, [_surf]
;  push eax
;  mov eax, [eax]
;  call dword [eax + 64h] ; surface->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
;
;  ; copy screen contents to surface
;  ; CopyMemory((WORD *) ddsd.lpSurface, _scr, 640*480*2);
;  mov ecx, SCR_SIZE / 2
;  mov esi, _scr
;  mov edi, [_ddsd + 36d] ; ddsd.lpSurface
;  cld
;  rep movsw
;
;  ; unlock surface
;  push dword [_ddsd + 36d] ; ddsd.lpSurface
;  mov eax, [_surf]
;  push eax
;  mov eax, [eax]
;  call dword [eax + 80h] ; surface->Unlock(NULL);
;
;  @@:
;
;;;  ; fill with purple color
;;;  pop ecx
;;;  mov ax, 7C1Fh
;;;  mov edi, [buff]
;;;  cld
;;;  rep stosw
;  ret
;endp

proc MemPatch stdcall uses eax ebx ecx edx edi esi ebp, offs:DWORD, size:DWORD, data:DWORD
  ; save offs
  mov ebx, [offs]
  ; change access rights
  push ecx
  mov eax, esp
  invoke VirtualProtect, ebx, [size], PAGE_EXECUTE_READWRITE, eax
  test eax, eax
  jz @mpq
    ; change data
    mov edi, ebx
    mov esi, [data]
    mov ecx, [size]
    cld
    rep movsb
    ; if that was an address
    cmp dword [size], 4
    jnz @f
      mov eax, [data]
      mov eax, [eax]
      sub eax, ebx
      sub eax, 4
      mov [ebx], eax
    @@:
    ; restore access rights
    pop ecx
    push ecx
    mov eax, esp
    invoke VirtualProtect, ebx, [size], ecx, eax
    invoke GetCurrentProcess
    invoke FlushInstructionCache, eax, ebx, [size]
  @mpq:
  ; restore stack
  pop eax
  ret
endp

proc ApplyPatches stdcall uses eax ecx edi
  ; patches offs
  mov edi, @_patches
  @@:
    ; size
    mov ecx, [edi]
    add edi, 4
    ; offs
    mov eax, [edi]
    add edi, 4
    ; change relative to absolute offs
    stdcall GetOffs, eax
    stdcall MemPatch, eax, ecx, edi
    ; skip data
    add edi, ecx
    ; terminator?
    cmp dword [edi], 0
  jnz @b
  ret
endp

proc FatalError stdcall _msg:DWORD
  ; show error message
  invoke MessageBoxA, 0, [_msg], 0, MB_OK or MB_ICONERROR or MB_TOPMOST
  ; exit process
  invoke ExitProcess, 0
  ; no ret since this is noreturn proc
endp

proc CheckVersion stdcall uses eax
  ; get handle of the file used to create the calling process
  stdcall GetOffs, 0
  ; go to PE header
  add eax, [eax + IMAGE_DOS_HEADER.e_lfanew]
  ; check ResidentEvil3.exe from the USA release by TimeDateStamp
  cmp dword [eax + IMAGE_NT_HEADERS.FileHeader.TimeDateStamp], 39D81B32h
  jz @f
    stdcall FatalError, _emsg_version
  @@:
  ret
endp

proc ResolveExport stdcall uses eax ecx ebx edx edi esi, hinstDLL:DWORD
  ; no thread calls
  invoke DisableThreadLibraryCalls, [hinstDLL]
  ; get system directory
  invoke GetSystemDirectoryA, _scr, SCR_SIZE - 16
  ; add library name
  invoke lstrcatA, _scr, _dll
  ; try to load library
  invoke LoadLibraryA, _scr
  test eax, eax
  jnz @f
    ; failed to load original DDRAW.DLL
    stdcall FatalError, _emsg_library
  @@:
  ; save ddraw hinst
  mov ebx, eax
  ; patch library current export -> original DDRAW.DLL import
  mov eax, [hinstDLL]
  add eax, [eax + IMAGE_DOS_HEADER.e_lfanew]
  ; IMAGE_DIRECTORY_ENTRY_EXPORT = 0
  add eax, IMAGE_NT_HEADERS.OptionalHeader.DataDirectory
  ; export virtual address
  add eax, IMAGE_DATA_DIRECTORY.VirtualAddress
  mov eax, [eax]
  add eax, [hinstDLL]
  ; total names count to fix
  mov ecx, [eax + IMAGE_EXPORT_DIRECTORY.NumberOfNames]
  mov edi, [hinstDLL]
  mov esi, edi
  add edi, [eax + IMAGE_EXPORT_DIRECTORY.AddressOfFunctions]
  add esi, [eax + IMAGE_EXPORT_DIRECTORY.AddressOfNames]
  ; fix export
  @fix_loop:
    ; save loop counter
    push ecx
    ; get export function name address
    mov eax, [hinstDLL]
    add eax, [esi]
    ; get address of original function
    invoke GetProcAddress, ebx, eax
    ; no error?
    test eax, eax
    jz @f
      mov edx, [edi]
      ; skip E9 jump byte
      inc edx
      add edx, [hinstDLL]
      ; put addr to stack
      push eax
      mov eax, esp
      ; fix export
      stdcall MemPatch, edx, 4, eax
      pop eax
    @@:
    ; next name
    add esi, 4
    ; next addr
    add edi, 4
    ; restore loop counter
    pop ecx
    ; next name
    dec ecx
    jnz @fix_loop
  ; save DDRAW.DLL handle
  mov [_dlh], ebx
  ret
endp

proc CleanupCode stdcall uses eax, ecx, edx
  ; unload DDRAW.DLL
  invoke FreeLibrary, dword [_dlh]
  ret
endp

proc DllEntryPoint hinstDLL, fdwReason, lpvReserved
  ; only when loading
  cmp [fdwReason], DLL_PROCESS_ATTACH
  jnz @f
    ; check main module version
    stdcall CheckVersion
    ; fix export
    stdcall ResolveExport, [hinstDLL]
    ; apply application code patches
    stdcall ApplyPatches
;    ; save dll handle instance
;    mov eax, [hinstDLL]
;    mov [_his], eax
  @@:
  ; only when unloading
  cmp [fdwReason], DLL_PROCESS_DETACH
  jnz @f
    stdcall CleanupCode
  @@:
  xor eax, eax
  inc eax
  ret
endp

@_patches:
; ---------------
; count (in bytes) MUST be dd !
;dd 4
;; offset MUST be dd !
;dd 0000EC93h + 1
;; data to patch here (count bytes)
;dd FillJPG
; ---------------
dd 4
dd 000248C0h + 1
dd FillSLD
; new accelerators
dd 1
dd 00004908h
db 0E8h ; call
; must be split to fixed
dd 4
dd 00004908h + 1
dd CmdKeys
; F2: 42 -> 45 new ID (40002 -> 40005)
dd 1
dd 006659FCh
db 045h
; F9: 41 -> 46 new ID (40001 -> 40006)
dd 1
dd 00665A1Ch
db 046h
;; call to additional code
;dd 2
;dd 00008775h
;db 090h ; nop
;db 0E8h ; call
;; split to fix
;dd 4
;dd 00008775h + 2
;dd GetAccels
; ---------------
;dd 1
;dd 00011034h
;db 0E8h ; call
;; must be split to fixed
;dd 4
;dd 00011034h + 1
;dd DrawPurple
; ++++
;dd 1
;dd 00010C4Ah
;db 0E8h ; call
;; must be split to fixed
;dd 4
;dd 00010C4Ah + 1
;dd GetDDI
; ---------------
; default bio3.ini value for "MOVIE=" key
dd 5 ; five since this address don't need to be converted
dd 00004081h
db 068h
dd 0051BAE6h
; "zmovie\dino.str" => "zmovie\0"
dd 1
dd 0011BAECh ; 51BAECh
db 000h
;dd _zmovie
; subtitle text padding fix 06h -> 22h
dd 1
dd 0002DAB0h
db 022h
dd 1
dd 0002DB0Dh
db 022h
dd 1
dd 0002F56Ch
db 022h
dd 1
dd 0002F584h
db 022h
dd 1
dd 0002F5A9h
db 022h
dd 1
dd 0002F5BBh
db 022h
; some other text padding fixes
dd 1
dd 0003E883h
db 022h
dd 1
dd 0003EF7Fh
db 022h
dd 1
dd 000495E9h
db 022h
; discard item / puzzles text padding fix
dd 1
dd 0002E1BDh
db 01Eh
; ---------------
; !!!WARNING!!!
; next patches skips fade in/fade out delays
; like company logos at startup, in main menu and texts
; but broke some game logic - for example "Status Screen"
; key WILL NOT work until you load a next room,
; pickup an item, open a chest or reload scene data somehow
;dd 0 ; DEBUG_STOP
;; DEBUG FEATURES
;dd 1
;dd 0002AFC0h
;db 085h
;
;dd 1
;dd 00024D2Bh
;db 085h
;
;dd 1
;dd 0004F89Ch
;db 000h
;
;dd 1
;dd 0002F4B0h
;db 0C3h
; ---------------
dd 0 ; terminator

;_dumpfile db 'BACKDUMP.TGA',0
;_tgahead db\
;000h, 000h, 002h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 080h, 002h, 0E0h, 001, 010h, 023h

_dll db '\DDRAW.DLL',0
_emsg_version db 'This DDRAW.DLL file must be used only with the USA version of the ResidentEvil3.exe executable.',0
_emsg_library db 'Failed to load original system DDRAW.DLL library file.',0

;include 'ddrwhook.asm'
; single file without need of 'ddrwhook.asm'

; stubs

align 4
@AcquireDDThreadLock:
db 0E9h
dd 0

align 4
@CheckFullscreen:
db 0E9h
dd 0

align 4
@CompleteCreateSysmemSurface:
db 0E9h
dd 0

align 4
@D3DParseUnknownCommand:
db 0E9h
dd 0

align 4
@DDGetAttachedSurfaceLcl:
db 0E9h
dd 0

align 4
@DDInternalLock:
db 0E9h
dd 0

align 4
@DDInternalUnlock:
db 0E9h
dd 0

align 4
@DSoundHelp:
db 0E9h
dd 0

align 4
@DirectDrawCreate:
db 0E9h
dd 0

align 4
@DirectDrawCreateClipper:
db 0E9h
dd 0

align 4
@DirectDrawCreateEx:
db 0E9h
dd 0

align 4
@DirectDrawEnumerateA:
db 0E9h
dd 0

align 4
@DirectDrawEnumerateExA:
db 0E9h
dd 0

align 4
@DirectDrawEnumerateExW:
db 0E9h
dd 0

align 4
@DirectDrawEnumerateW:
db 0E9h
dd 0

align 4
@DllCanUnloadNow:
db 0E9h
dd 0

align 4
@DllGetClassObject:
db 0E9h
dd 0

align 4
@GetDDSurfaceLocal:
db 0E9h
dd 0

align 4
@GetOLEThunkData:
db 0E9h
dd 0

align 4
@GetSurfaceFromDC:
db 0E9h
dd 0

align 4
@RegisterSpecialCase:
db 0E9h
dd 0

align 4
@ReleaseDDThreadLock:
db 0E9h
dd 0

section '.data' data readable writeable
_dlh rd 1
;_his rd 1
;_ddi rd 1
;_surf rd 1
;_ddsd rd 31
;_DDBLTFX rd 25
_scr rb SCR_SIZE

section '.rdata' data readable

data import
  library kernel32, 'KERNEL32.DLL', user32, 'USER32.dll'
  import kernel32,\
    DisableThreadLibraryCalls, 'DisableThreadLibraryCalls',\
    GetSystemDirectoryA, 'GetSystemDirectoryA',\
    FlushInstructionCache, 'FlushInstructionCache',\
    GetCurrentProcess, 'GetCurrentProcess',\
    LoadLibraryA, 'LoadLibraryA',\
    FreeLibrary, 'FreeLibrary',\
    GetProcAddress, 'GetProcAddress',\
    GetModuleHandle, 'GetModuleHandleA',\
    VirtualProtect, 'VirtualProtect',\
    CreateFileA, 'CreateFileA',\
    CloseHandle, 'CloseHandle',\
    WriteFile, 'WriteFile',\
    ExitProcess, 'ExitProcess',\
    lstrcatA, 'lstrcatA'
  import user32,\
    LoadAcceleratorsA, 'LoadAcceleratorsA',\
    MessageBoxA, 'MessageBoxA'
end data

data export
  export 'DDRAW.dll',\
    @AcquireDDThreadLock, 'AcquireDDThreadLock',\
    @CheckFullscreen, 'CheckFullscreen',\
    @CompleteCreateSysmemSurface, 'CompleteCreateSysmemSurface',\
    @D3DParseUnknownCommand, 'D3DParseUnknownCommand',\
    @DDGetAttachedSurfaceLcl, 'DDGetAttachedSurfaceLcl',\
    @DDInternalLock, 'DDInternalLock',\
    @DDInternalUnlock, 'DDInternalUnlock',\
    @DSoundHelp, 'DSoundHelp',\
    @DirectDrawCreate, 'DirectDrawCreate',\
    @DirectDrawCreateClipper, 'DirectDrawCreateClipper',\
    @DirectDrawCreateEx, 'DirectDrawCreateEx',\
    @DirectDrawEnumerateA, 'DirectDrawEnumerateA',\
    @DirectDrawEnumerateExA, 'DirectDrawEnumerateExA',\
    @DirectDrawEnumerateExW, 'DirectDrawEnumerateExW',\
    @DirectDrawEnumerateW, 'DirectDrawEnumerateW',\
    @DllCanUnloadNow, 'DllCanUnloadNow',\
    @DllGetClassObject, 'DllGetClassObject',\
    @GetDDSurfaceLocal, 'GetDDSurfaceLocal',\
    @GetOLEThunkData, 'GetOLEThunkData',\
    @GetSurfaceFromDC, 'GetSurfaceFromDC',\
    @RegisterSpecialCase, 'RegisterSpecialCase',\
    @ReleaseDDThreadLock, 'ReleaseDDThreadLock'
end data

;section '.rsrc' resource data readable
;
;  directory RT_ACCELERATOR, accelerators
;
;  resource accelerators,113,LANG_ENGLISH+SUBLANG_DEFAULT,re3keys
;
;  accelerator re3keys,\
;    FVIRTKEY+FNOINVERT,VK_F1,40004,\
;    FVIRTKEY+FNOINVERT,VK_F2,40002,\
;    FVIRTKEY+FNOINVERT+FALT,VK_F4,40001,\
;    FVIRTKEY+FNOINVERT,VK_F5,40002,\
;    FVIRTKEY+FNOINVERT,VK_F8,40003,\
;    FVIRTKEY+FNOINVERT,VK_F9,40001,\
;    FVIRTKEY+FNOINVERT+FALT,VK_RETURN,40003,\
;    FVIRTKEY+FNOINVERT,VK_F7,40005

section '.reloc' fixups data readable discardable
