unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IniFiles;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Edit3: TEdit;
    Bevel1: TBevel;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    Edit5: TEdit;
    ComboBox1: TComboBox;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function bswap32(i: dword): dword; assembler;
asm
  bswap eax
end;

function gethexval(s: string): dword;
begin
  result:=0;
  while length(s) < 8 do s:='0' + s;
  s:=trim(LowerCase(s));
  HexToBin(PChar(s), PChar(@result), 4);
  result:=bswap32(result);
end;

function getwndval: HWND;
var
  c, n: string;
  cp, np: pchar;
begin
  c:=Form1.Edit4.Text;
  n:=Form1.Edit5.Text;
  cp:=nil;
  np:=nil;
  if (c <> '') then cp:=pchar(c);
  if (n <> '') then np:=pchar(n);
  result:=FindWindow(cp, np);  
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: DWORD;
  h: THandle;
  d: cardinal;
begin
  i:=0;
  GetWindowThreadProcessId(getwndval, i);
  Edit1.Text:=IntToStr(i);
  if (i = 0) then exit;
  h:=OpenProcess(PROCESS_ALL_ACCESS, False, i);
  if (h <> 0) then
  begin
    i:=gethexval(ComboBox1.Text);
    ReadProcessMemory(h, pointer(i), @i, 4, d);
    Edit3.Text:=IntToHex(i, 8);;
    for d:=31 downto 0 do
      TCheckBox(Form1.FindComponent('b' + IntToStr(d))).Checked:=((i and (1 shl d)) <> 0);
    CloseHandle(h);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i: DWORD;
  h: THandle;
  d, v, r: cardinal;
begin
  i:=0;
  GetWindowThreadProcessId(getwndval, i);
  Edit1.Text:=IntToStr(i);
  if (i = 0) then exit;
  h:=OpenProcess(PROCESS_ALL_ACCESS, False, i);
  if (h <> 0) then
  begin
    i:=gethexval(ComboBox1.Text);
    v:=gethexval(Edit3.Text);
    VirtualProtectEx(h, pointer(i), 4, PAGE_READWRITE, r);
    WriteProcessMemory(h, pointer(i), @v, 4, d);
    VirtualProtectEx(h, pointer(i), 4, r, r);    
    CloseHandle(h);
  end;
end;

procedure TForm1.BClick(Sender: TObject);
var i, v: DWORD;
begin
  v:=0;
  for i:=31 downto 0 do
  begin
    v:=v shl 1;
    v:=v or byte(ord(TCheckBox(Form1.FindComponent('b' + IntToStr(i))).Checked = True));
  end;
  Edit3.Text:=IntToHex(v, 8);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i, x, y: integer;
  b: TCheckBox;
  n: TIniFile;
  s: string;
begin
  x:=10;
  y:=Bevel1.Top + Bevel1.Height;
  for i:=31 downto 0 do
  begin
    b:=TCheckBox.Create(Form1);
    b.Name:='b' + IntToStr(i);
    b.Caption:=IntToStr(i);
    b.Width:=25;
    b.Height:=25;
    b.Left:=x;
    b.Top:=y;
    b.OnClick:=BClick;
    b.Parent:=Form1;
    // http://www.sql.ru/forum/394039/nuzhna-knopka-fiksiruushhayasya-v-rezhimah-down-up
    SetWindowLong(b.Handle, GWL_STYLE, GetWindowLong(b.Handle, GWL_STYLE) or BS_PUSHLIKE);
    if ((i and 7) = 0) then
    begin
      y:=y + b.Height;
      x:=10;
    end
    else
      x:=x + b.Width;
  end;
  n:=TIniFile.Create(Copy(ParamStr(0), 1, length(ParamStr(0)) - 4) + '.ini');
  Edit4.Text:=n.ReadString('flagtest', 'WindowClass', '');
  Edit5.Text:=n.ReadString('flagtest', 'WindowTitle', '');
  i:=0;
  repeat
    s:=n.ReadString('flagtest', 'Addr' + IntToStr(i), '');
    if (s <> '') then
      ComboBox1.Items.Add(s);
    i:=i + 1;
  until (s = '');
  n.Free;
  if (ComboBox1.Items.Count > 0) then
    ComboBox1.Text:=ComboBox1.Items[0]
  else
    ComboBox1.Text:='0';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  n: TIniFile;
  i: integer;
begin
  n:=TIniFile.Create(Copy(ParamStr(0), 1, length(ParamStr(0)) - 4) + '.ini');
  n.WriteString('flagtest', 'WindowClass', Edit4.Text);
  n.WriteString('flagtest', 'WindowTitle', Edit5.Text);
  for i:=0 to ComboBox1.Items.Count - 1 do
    n.WriteString('flagtest', 'Addr' + IntToStr(i), ComboBox1.Items[i]);
  n.Free;
end;

procedure TForm1.ComboBox1KeyPress(Sender: TObject; var Key: Char);
var s: string;
begin
  s:=trim(ComboBox1.Text);
  if ((Key = #13) and (s <> '')) then
  begin
    while (length(s) < 8) do s:='0' + s;
    if (ComboBox1.Items.IndexOf(s) = -1) then
      ComboBox1.Items.Add(s);
  end;
  ComboBox1.Text:=s;  
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  s: string;
  i: integer;
begin
  s:=trim(ComboBox1.Text);
  i:=1;
  while (i <= length(s)) do
  begin
    if (
      ((s[i] >= '0') and (s[i] <= '9')) or
      ((UpCase(s[i]) >= 'A') and (UpCase(s[i]) <= 'F'))
    ) then
      i:=i + 1
    else
      Delete(s, i, 1);
  end;
  if (s = '') then s:='0';
  if (s <> ComboBox1.Text) then ComboBox1.Text:=s;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  wnd: HWND;
  rc: TRect;
begin
  wnd:=getwndval;
  if (wnd <> 0) then
  begin
    if (IsIconic(wnd) = true) then ShowWindow(wnd, SW_RESTORE);
    SetWindowPos(wnd, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE or SWP_SHOWWINDOW);
    GetWindowRect(wnd, rc);
    Form1.Left:=rc.Right + 10;
    Form1.Top:=rc.Top + 10;    
  end;
end;

end.
