#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>

#ifdef GCC32HACK
#include "win32gcc.h"
#endif

#pragma pack(push, 1)
/* 320x160 */
typedef struct {
  DWORD pname;  /* ptr to movie filename */
  WORD  count;  /* count = (frames / 2) - 5 (>= 12) */
  WORD  data2;  /* unknown always 0x00FF */
  WORD  data3;  /* flags?., usually 0x0010 */
  DWORD width;  /* always 0x140 */
  WORD height;
  WORD  data4;
  WORD  data5;
  DWORD data6;
} mov_info;
#pragma pack(pop)

DWORD StrToInt(char *s) {
DWORD result;
  result = 0;
  for (; *s; s++) {
    if ((*s >= '0') && (*s <= '9')) {
      result *= 10;
      result += (*s - '0');
    } else {
      result = 0;
      break;
    }
  }
  return(result);
}

char *basename(char *s) {
char *r;
  for (r = s; *r; r++) {
    if ((*r == '\\') || (*r == '/')) {
      s = &r[1];
    }
  }
  return(s);
}

int main(int argc, char *argv[]) {
mov_info list[14];
char s[32];
FILE *fl;
DWORD i, l;
  printf(
    "Resident Evil 3 FMV duration frames limit changer\n"\
    "(c) -=CHE@TER=- 2017\n"
    "http://ctpax-cheater.losthost.org/\n"
    "\n"
  );
  fl = fopen("ResidentEvil3.exe", "rb+");
  if (!fl) {
    printf("Error: can not open \"ResidentEvil3.exe\" for read-write.\n\n");
    return(1);
  }
  fseek(fl, 0x000011B978, SEEK_SET);
  fread(&list, sizeof(list[0]), 14, fl);
/*  printf(";---\n");*/
  printf(
    " # | frames | filename\n"
/*    "---+--------+-----------\n"*/
  );
  if (argc != 3) {
    for (i = 0; i < 14; i++) {
      fseek(fl, 0x0000110000 + (list[i].pname & 0xFFFF), SEEK_SET);
      fread(s, 1, 32, fl);
      s[31] = 0;
      strcpy(s, basename(s));
      l = strlen(s);
      s[l - 3] = 'd';
      s[l - 2] = 'a';
      s[l - 1] = 't';
      printf("%2lu | %6d | %s\n", i + 1, (list[i].count + 5) * 2, s);
/*      printf(
        "%08lX %04X %04X %04X %08lX %04X %04X %04X %08lX %s\n",
        list[i].pname, list[i].count, list[i].data2, list[i].data3,
        list[i].width, list[i].height, list[i].data4, list[i].data5,
        list[i].data6, s
      );*/
    }
    printf(
      "\nUsage: %s i f\nWhere: i - movie clip number (#); f - new frames count\n",
      basename(argv[0])
    );
  } else {
    i = StrToInt(argv[1]);
    l = StrToInt(argv[2]);
    if ((i >= 1) && (i <= 14)) {
      if ((l >= 12) && (l <= 131080)) {
        list[i - 1].count = ((l / 2) - 5);
        fseek(fl, 0x000011B978, SEEK_SET);
        fwrite(&list, sizeof(list[0]), 14, fl);
        printf("Movie #%lu length: %lu frames [changed]\n\n", i, l);
      } else {
        printf("Error: invalid frames count, must be from 12 to 131080 (inclusive).\n\n");
      }
    } else {
      printf("Error: invalid movie clip number, must be from 1 to 14 (inclusive).\n\n");
    }
  }
  fclose(fl);
  return(0);
}
